// MainWindow.cs created with MonoDevelop
// User: lliurex-admin at 11:42 25/11/2009
//
// To change standard headers go to Edit->Preferences->Coding->Standard Headers
//
using System;
using Gtk;
using Mono.Unix;
using System.IO;
using System.Timers;
using System.Collections;
using lliurex;

namespace lliurex.easysites{

public partial class MainWindow: Gtk.Window
{	
	public delegate void ClosedEvent(String arg); 
		public event ClosedEvent OnClose;
		
	
	public string errorMessage = "";
	public string originalErrorMessage = "";
	public lliurex.easysites.progressWindow pWindow;	
	//private System.Collections.Generic.Dictionary<string,string> dictionarySites;
	private string pathToLinks = "/usr/share/llxcfg-httpd/httpd/srv/links/";
	
	public MainWindow (): base (Gtk.WindowType.Toplevel)
	{

		Build ();
		originalErrorMessage = label_error.Text;
		
	}
	
	protected void OnDeleteEvent (object sender, DeleteEventArgs a)
	{
		Application.Quit ();
		a.RetVal = true;
	}

	protected virtual void OnButton3Clicked (object sender, System.EventArgs e)
	{
			OnClose("Destroy");
			this.Destroy();
	}

	protected virtual void OnEntry1Changed (object sender, System.EventArgs e)
	{
		string aux_text = entry1.Text;
		entry1.Text=aux_text.Replace(" ","");
	}

	protected virtual void OnButton2Clicked (object sender, System.EventArgs e)
	{
		
		if (checkValues())
		{
				
			Console.WriteLine("DEBUG:MainWindow:CheckValues");
				
			// GTK
			this.Hide();
			
			Gtk.Application.Invoke(delegate{pWindow=new progressWindow();});
			System.Threading.Thread exeThread;
			System.Threading.ThreadStart exeTStart;
			exeTStart=delegate 
			{
				label_error.Visible = false;			
				Console.WriteLine("DEBUG:MainWindow:Run: /usr/sbin/llxcfg-httpd -u enabledir "+foldersite.Filename+" "+entry1.Text+" " );	
				lliurex.utils.Commands.run("/usr/sbin/llxcfg-httpd", "-u enabledir "+foldersite.Filename+" "+entry1.Text+" " );
				pWindow.pulse=false;
				pWindow.Hide();
				lliurex.easysites.easyMain.getEasyMain().replenishSites();
				
			};
			exeThread=new System.Threading.Thread(exeTStart);
			exeThread.Start();		
			if (ckvisible.Active)
			{				
				
				//Create link contents
				// URL
				string mylink = "http://"+entry1.Text+"\n";
				
				// Name
				mylink += ""+linkname.Text+"\n";
				
				// Image
				mylink += "\n";
				
				// Description is not needed
				if (entryDescription.Text.Length > 0)
				{
					mylink += ""+entryDescription.Text+"\n";
				}
				
				// Write file
				File.WriteAllText(pathToLinks+entry1.Text+".link",mylink);		
			}
			
			
		}
		else
		{
				 
				label_error.Text = originalErrorMessage+" "+errorMessage;
			label_error.Visible = true;
				errorMessage = " ";
				
		}
		
				
		
	}
	
	protected  bool checkValues()
	{
		bool correct = true;
		if (entry1.Text.Length == 0) 
		{
			correct = false;
			errorMessage += Mono.Unix.Catalog.GetString("\n * Site name is blank");
		}
			
			else 
			{
				System.Diagnostics.Process proc = new System.Diagnostics.Process();	
				proc.StartInfo.UseShellExecute = false;
				proc.EnableRaisingEvents = true;
			
				proc.StartInfo.FileName = "/usr/sbin/llxcfg-httpd";			
				proc.StartInfo.Arguments = " testsite "+entry1.Text+" ";

				proc.Start();
				proc.WaitForExit();
				int exitCode = proc.ExitCode;
				
				if (exitCode == 1)
				{
					correct = false;
					errorMessage += Mono.Unix.Catalog.GetString("\n * Site name is in use");
				}
					
			}
		
		DirectoryInfo dir = new DirectoryInfo(foldersite.Filename);
		if (! dir.Exists)
		{
			correct = false;
			errorMessage += Mono.Unix.Catalog.GetString("\n * Directory not exists");
		}

		if (ckvisible.Active)
		{
			if (linkname.Text.Length == 0)
			{
				correct = false;
				errorMessage += Mono.Unix.Catalog.GetString("\n * If site is visible needs a name");
			}
			
		}
		
		return correct; 
		
			
	}
	
	
	
	
}
	
}
