// easyMain.cs created with MonoDevelop
// User: lliurex-admin at 9:21 26/11/2009
//
// To change standard headers go to Edit->Preferences->Coding->Standard Headers
//

using System;
using Gtk;
using lliurex;

namespace lliurex.easysites
{
	
	
	public partial class easyMain : Gtk.Window
	{

		public Gtk.ListStore sitesListStore; 
		
		public static lliurex.easysites.easyMain singleton;
		
		public easyMain() : 
				base(Gtk.WindowType.Toplevel)
		{
			this.Build();
			singleton=this;
			// Create columns on treeview
			Gtk.TreeViewColumn siteNameColumn = new TreeViewColumn();
			siteNameColumn.Title = "Sites";
			Gtk.TreeViewColumn siteEnableColumn = new TreeViewColumn();
			siteEnableColumn.Title = " ";
			
			treeviewSites.AppendColumn(siteEnableColumn);
			treeviewSites.AppendColumn(siteNameColumn);
			
			
			sitesListStore = new Gtk.ListStore (typeof (string), typeof (bool));
			treeviewSites.Model = sitesListStore;
			
			Gtk.CellRendererText siteNameCell = new Gtk.CellRendererText ();
			Gtk.CellRendererToggle siteEnabledCell = new Gtk.CellRendererToggle ();
			
			siteEnabledCell.Toggled += new ToggledHandler(OnToggledButton);
			
			siteEnableColumn.PackStart(siteEnabledCell,true);
			siteNameColumn.PackStart(siteNameCell,true);
			
			
			siteNameColumn.AddAttribute(siteNameCell,"text",0);
			siteEnableColumn.AddAttribute(siteEnabledCell,"active",1);
			
			replenishSites();
			
		}
		
		public static easyMain getEasyMain()
		{
			if(singleton==null)
			{
				singleton=new easyMain();
				Console.WriteLine("Creating new easyMain");
			}
			else
				Console.WriteLine("Returning easyMain instance");
			return singleton;
		}
		

		protected void OnToggledButton(object o, ToggledArgs args)
		{
			System.Console.WriteLine(args.Path);
			TreePath myPath = new TreePath(args.Path);
			
			TreeIter myIter;
			sitesListStore.GetIter(out myIter, myPath);
						
			bool active = (bool)sitesListStore.GetValue(myIter,1);
			sitesListStore.SetValue(myIter,1,!active);				
			
		}
		
		public void OnWindowAddClose(string args)
		{
			replenishSites();
			
			
		}
		
		protected virtual void OnButtonAddClicked (object sender, System.EventArgs e)
		{
			lliurex.easysites.MainWindow win = new MainWindow();
			win.OnClose += new MainWindow.ClosedEvent(OnWindowAddClose);
			win.Show();
		}
		protected virtual void OnButtonDelClicked (object sender, System.EventArgs e)
		{
			TreeIter myIter;
			bool notHaveTheEnd;
			notHaveTheEnd = sitesListStore.GetIterFirst(out myIter);
			
			string sitesToDelete = "";
			while ( notHaveTheEnd)
			{
				
				if ((bool)sitesListStore.GetValue(myIter,1))
				{
					
				sitesToDelete += sitesListStore.GetValue(myIter,0)+" ";
					
				}
				notHaveTheEnd = sitesListStore.IterNext(ref myIter);
				
			}
			
			if (sitesToDelete.Length > 0)
			{
			System.Diagnostics.Process listProc = new System.Diagnostics.Process();
			listProc.StartInfo.UseShellExecute = false;
			listProc.StartInfo.FileName = "/usr/sbin/llxcfg-httpd";	
			listProc.StartInfo.Arguments = "-u disablesite "+sitesToDelete;
			listProc.StartInfo.RedirectStandardOutput = true;
			
			listProc.Start();
			listProc.WaitForExit();
			}
			    
			replenishSites();
			
		}

		protected virtual void OnButtonExitClicked (object sender, System.EventArgs e)
		{
			Application.Quit ();
		}
		
		
		public void replenishSites()
		{
			Console.WriteLine("Refreshing list...");
			Console.WriteLine("DEBUG:easyMain:repleni");
			sitesListStore.Clear();
			System.Diagnostics.Process listProc = new System.Diagnostics.Process();
			listProc.StartInfo.UseShellExecute = false;
			listProc.StartInfo.FileName = "/usr/sbin/llxcfg-httpd";	
			listProc.StartInfo.Arguments = " listcustomsites";
			listProc.StartInfo.RedirectStandardOutput = true;
			
			listProc.Start();
			listProc.WaitForExit();
			
			string listSites = listProc.StandardOutput.ReadToEnd();
			listSites = listSites.Trim('\n');
			string[] arrayListSites = listSites.Split(' ');
		
			for (int n = 0; n<arrayListSites.Length; n++)
			{
				
				sitesListStore.AppendValues(arrayListSites[n],false);
				
			}
			
				sitesListStore.Append();
		}
		
	}
}
